Index: Singular/LIB/hnoether.lib
===================================================================
--- Singular/LIB/hnoether.lib	(revision 54ff35fb086438cda61fdfdc9ab33efa8472e4eb)
+++ Singular/LIB/hnoether.lib	(revision 7fa60f271650fb75da945dbf4eae02cf8cc5a570)
@@ -3841,12 +3701,14 @@
        HNEakut[zeile+zl+1]=poly(0);
        HNEs[hnezaehler]=HNEakut;
- //-------------------- Ende der Eintragungen in HNEs -------------------------
+       conj1[hneshift+hnezaehler]=conj2[j];
+
+       //-------------------- Ende der Eintragungen in HNEs -------------------
 
        if (eis[j]>1) {
         transformiert=transformiert/y;
-        if (subst(transformiert,y,0)==0) {
- "THE TEST FOR SQUAREFREENESS WAS BAD!! The polynomial was NOT squarefree!!!";}
+        if (subst(transformiert,y,0)==0){"THE TEST FOR SQUAREFREENESS WAS BAD!"
+                               +" The polynomial was NOT squarefree!!!";}
          else {
- //--------- Spezialfall (###) eingetreten: Noch weitere Zweige vorhanden -----
+          //--- Spezialfall (###) eingetreten: Noch weitere Zweige vorhanden --
           eis[j]=eis[j]-1;
        }}
@@ -3854,23 +3716,43 @@
     }                             // endelse (R<>0)
 
- //========== Falls HNE nicht abbricht: Rekursiver Aufruf von HN: =============
- //------------------- Berechne HNE von transformiert -------------------------
+    //========== Falls HNE nicht abbricht: Rekursiver Aufruf von HN: ==========
+    //------------------- Berechne HNE von transformiert ----------------------
     if (subst(transformiert,y,0)!=0) {
      lastRingnumber=EXTHNEnumber;
-     list HNerg=HN(transformiert,eis[j],Aufruf_Ebene+1,essential);
-     if (HNerg[2]==-1) {          // kein Ringwechsel in HN aufgetreten
-       aneu=HNerg[1];  }
-     else {
+
+     if (EXTHNEnumber>0){ EXTHNEring = EXTHNEring(1..EXTHNEnumber); }
+     HNE_RingDATA = list( HNEring, HNE_noparam, EXTHNEnumber, EXTHNEring, 
+                          lastRingnumber); 
+     if (defined(HNerg)) {kill HNerg;}
+     list HNerg=HN(HNE_RingDATA,transformiert,eis[j],Aufruf_Ebene+1,
+                                essential,getauscht,hne_conj,conj2[j]);    
+     HNE_RingDATA = HNerg[1];
+     if (conj1==0) { conj1=HNerg[5]; }
+     else  { conj1 = conj1,HNerg[5]; }
+
+     if (HNerg[3]==1) { field_ext=1; }
+     if (HNerg[2]==lastRingnumber) { // kein Ringwechsel in HN aufgetreten
+       if (not(defined(aneu))) { list aneu; }
+       aneu = HNerg[4];
+     }
+     else { // Ringwechsel aufgetreten
        if (defined(HNDebugOn))
           {" ring change in HN(",Aufruf_Ebene+1,") detected";}
-       list aneu=HNerg[1];
-       poly transfproc=HNerg[2];
-
- //- stelle lokale Var. im neuen Ring wieder her und rette ggf. ihren Inhalt: -
-       list erg,hilflist,faktoren,HNEakut;
-       ideal hilfid;
-       erg=ideal(0); hilflist=erg; faktoren=erg; HNEakut=erg;
+       EXTHNEnumber = HNerg[1][3];
+       for (i=lastRingnumber+1; i<=EXTHNEnumber; i++) { 
+         def EXTHNEring(i)=HNerg[1][4][i]; 
+       } 
+       if (HNerg[2]==0) { setring HNEring; }
+       else             { setring EXTHNEring(HNerg[2]); }
+       def tempRing=HNerg[4];
+       def aneu=imap(tempRing,HNEs);
+       kill tempRing;
+
+       //--- stelle lokale Variablen im neuen Ring wieder her, und rette 
+       //    gegebenenfalls ihren Inhalt: ----
+       list erg,faktoren,HNEakut;
+       ideal hilfid;      
+       erg=ideal(0); faktoren=erg; HNEakut=erg;
        poly leitf,teiler,transformiert;
-
        map hole=HNE_noparam,transfproc,x,y;
        setring HNE_noparam;
@@ -3878,8 +3760,16 @@
        else                  { def letztring=HNEring; }
        HNEs=imap(letztring,HNEs);
+       if (not defined(azeilen)) {list azeilen;}
        azeilen=imap(letztring,azeilen);
+       if (not defined(deltais)) {ideal deltais;}
        deltais=imap(letztring,deltais);
+       if (not defined(delt)) {poly delt;}
        delt=imap(letztring,delt);
+       if (not defined(fneu)) {poly fneu;}
+       fneu=imap(letztring,fneu);
+       if (not defined(f)) {poly f;}
        f=imap(letztring,f);
+       if (not defined(hne)) {list hne;}
+       hne=imap(letztring,hne);
 
        setring EXTHNEring(EXTHNEnumber);
@@ -3888,15 +3778,18 @@
        ideal deltais=hole(deltais);
        number delt=number(hole(delt));
-       poly f=hole(f);
+       poly fneu=hole(fneu);
+       if (not(defined(f)))
+       { 
+         poly f=hole(f);
+         list hne=hole(hne);
+         export f,hne;
+       }
      }
-     kill HNerg;
- //----------------------------------------------------------------------------
- // HNerg muss jedesmal mit "list" neu definiert werden, weil vorher noch nicht
- // ------- klar ist, ob der Ring nach Aufruf von HN noch derselbe ist --------
-
- //============= Verknuepfe bisherige HNE mit von HN gelieferten HNEs: ========
+
+     //========== Verknuepfe bisherige HNE mit von HN gelieferten HNEs: ======
      if (R==0) {
        HNEs,hnezaehler=constructHNEs(HNEs,hnezaehler,aneu,azeilen,zeile,
                        deltais,Q,j);
+       kill aneu; 
      }
      else {
@@ -3905,8 +3798,8 @@
        HNEakut=azeilen;          // dupliziere den gemeinsamen Anfang der HNE's
        zl=2;                     // (kommt schliesslich nach HNEs[hnezaehler])
- //---------------- Trage Beitrag dieser Transformation T2 ein: ---------------
- //--------- Zur Bedeutung von zeile, zl: siehe Kommentar weiter oben ---------
-
- //--------- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: -------
+       //------------ Trage Beitrag dieser Transformation T2 ein: -------------
+       //------ Zur Bedeutung von zeile, zl: siehe Kommentar weiter oben ------
+
+       //----- vollziehe Euklid.Alg. nach, um die HN-Matrix zu berechnen: -----
        M1=M;N1=N;R1=R;Q1=M1/ N1;
        while (R1!=0) {
@@ -3915,5 +3808,5 @@
         HNEakut[zeile+zl][Q1+1]=x;    // Markierung des Zeilenendes der HNE
         zl=zl+1;
- //-------- Bereitstellung von Speicherplatz fuer eine neue Zeile: ------------
+        //----- Bereitstellung von Speicherplatz fuer eine neue Zeile: --------
         HNEakut[zeile+zl]=ideal(0);
         M1=N1; N1=R1; R1=M1%N1; Q1=M1 / N1;
@@ -3924,5 +3817,5 @@
        HNEakut[zeile+zl][Q1]=delt;
 
- //--- Daten aus T2_Transform sind eingetragen; haenge Daten von HN an: -------
+       //-- Daten aus T2_Transform sind eingetragen; haenge Daten von HN an: --
        hilfid=HNEakut[zeile+zl];
        for (zl1=Q1+1; zl1<=ncols(aneu[zaehler][2]); zl1++) {
@@ -3930,14 +3823,16 @@
        }
        HNEakut[zeile+zl]=hilfid;
- //--- vorher HNEs[.][zeile+zl]<-aneu[.][2], jetzt [zeile+zl+1] <- [3] usw.: --
+       // ------ vorher HNEs[.][zeile+zl]<-aneu[.][2], 
+       //        jetzt [zeile+zl+1] <- [3] usw.: --------
        for (zl1=3; zl1<=size(aneu[zaehler]); zl1++) {
          HNEakut[zeile+zl+zl1-2]=aneu[zaehler][zl1];
        }
- //--- setze die hqs zusammen: HNEs[hnezaehler][1]=HNEs[..][1],aneu[..][1] ----
+       //--- setze hqs zusammen: HNEs[hnezaehler][1]=HNEs[..][1],aneu[..][1] --
        hilfvec=HNEakut[1],aneu[zaehler][1];
        HNEakut[1]=hilfvec;
- //----------- weil nicht geht: liste[1]=liste[1],aneu[zaehler][1] ------------
+       //-------- weil nicht geht: liste[1]=liste[1],aneu[zaehler][1] ---------
        HNEs[hnezaehler]=HNEakut;
       }                     // end(for zaehler)
+     kill aneu;
      }                      // endelse (R<>0)
     }                       // endif (subst()!=0)  (weiteres Aufblasen mit HN)
@@ -3945,19 +3840,183 @@
    }                        // end(for j) (Behandlung der einzelnen delta_i)
 
-  }
-  export HNEs;
-  keepring basering;
-  if (defined(transfproc)) { export transfproc;return(list(HNEs,transfproc)); }
-  else                     { return(list(HNEs,poly(-1))); }
- // -1 als 2. Rueckgabewert zeigt an, dass kein Ringwechsel stattgefunden hat -
+
+   // ------------------------- new for essdevelop ----------------------------
+   if ((essential==1) and (defined(SaveRing))) {
+     // ----- uebertrage Daten in gemeinsame Koerpererweiterung ---------------
+     if (EXTHNEnumber>number_of_letztring) {
+       // ----- fuer aktuelle Kante war Koerpererweiterung erforderlich -------
+       EXTHNEnumber++;
+       if (not(defined(minPol))) { poly miniPol; }
+       miniPol=minpoly;
+       setring SaveRing;
+       if (not(defined(miniPol))) { poly miniPol; }
+       miniPol=minpoly;
+       setring HNE_noparam;
+       if (not(defined(a_x))){ map a_x,a_y; poly mp_save, mp_new; }
+       mp_save=imap(SaveRing,miniPol); 
+       mp_new=imap(EXTHNEring(EXTHNEnumber-1),miniPol); 
+       if (mp_save==mp_new) { // Sonderfall: wieder gleicher Ring
+         def EXTHNEring(EXTHNEnumber)=SaveRing;
+         setring EXTHNEring(EXTHNEnumber);
+         if (not(defined(f))) {poly f; f=hole(f); export f;}
+         list dummyL=imap(EXTHNEring(EXTHNEnumber-1),HNEs);
+         if (not(defined(HNEs))) { def HNEs=list(); }
+         HNEs[size(HNEs)+1..size(HNEs)+size(dummyL)]=dummyL[1..size(dummyL)];
+         kill dummyL,SaveRing;
+       } 
+       else { // verschiedene Ringe
+         a_x=HNE_noparam,x,0,0;
+         a_y=HNE_noparam,y,0,0;
+         mp_save=a_x(mp_save); // minpoly aus SaveRing mit a --> x
+         mp_new=a_y(mp_new);   // minpoly aus SaveRing mit a --> y
+         setring SaveRing;
+         poly mp_new=imap(HNE_noparam,mp_new);
+         list Lfac=factorize(mp_new,1);
+         poly fac=Lfac[1][1];
+         for (k=2;k<=size(Lfac[1]);k++) {
+           if (deg(Lfac[1][k])<deg(fac)) { fac=Lfac[1][k]; } 
+         }
+
+         if (deg(fac)==1) { // keine Erweiterung noetig
+           def EXTHNEring(EXTHNEnumber)=SaveRing;
+           setring HNE_noparam;
+           HNEs=imap(EXTHNEring(EXTHNEnumber-1),HNEs);
+           setring EXTHNEring(EXTHNEnumber);
+           if (not(defined(f))) {poly f; f=hole(f); export f;}
+           map phi=HNE_noparam,-subst(fac,y,0)/koeff(fac,0,1),x,y;
+           list dummyL=phi(HNEs);
+           if (not(defined(HNEs))) { def HNEs=list(); }
+           if ((size(HNEs)==1) and (typeof(HNEs[1])=="ideal")) {HNEs=list();}
+           HNEs[size(HNEs)+1..size(HNEs)+size(dummyL)]=dummyL[1..size(dummyL)];
+           kill dummyL,phi,SaveRing;
+         }
+         else { // Koerpererweiterung noetig
+           def EXTHNEring(EXTHNEnumber) = splitring(fac,list(a,transfproc));
+           setring EXTHNEring(EXTHNEnumber);
+           poly transf=erg[1];  // image of parameter from SaveRing
+           poly transfproc=erg[2];
+           poly transb=erg[3];  // image of parameter from EXTHNEring(..)
+           export transfproc;
+           kill erg;
+           setring HNE_noparam;
+           if (not(defined(HNEs1))) { list HNEs1=ideal(0); } 
+           HNEs1=imap(EXTHNEring(EXTHNEnumber-1),HNEs);
+           if (not(defined(hne))) { list hne=ideal(0); } 
+           hne=imap(SaveRing,hne);
+           HNEs=imap(SaveRing,HNEs);
+           setring EXTHNEring(EXTHNEnumber);
+           map hole=HNE_noparam,transf,x,y;
+           poly fneu=hole(fneu);
+           poly f=hole(f); 
+           map phi=HNE_noparam,transb,x,y;
+           list HNEs=hole(HNEs);
+           list hne=hole(hne);
+           export f,hne;
+           if ((size(HNEs)==1) and (typeof(HNEs[1])=="ideal")) {HNEs=list();}
+           list dummyL=phi(HNEs1);
+           HNEs[size(HNEs)+1..size(HNEs)+size(dummyL)]=dummyL[1..size(dummyL)];
+           kill dummyL,phi,SaveRing;
+         }
+       }
+     }
+     else { // nur bei letzter Kante muss was getan werden
+       if (i==size(Newton)-1) { 
+         EXTHNEnumber++;
+         if (number_of_letztring==0) { def letztring=HNEring; }
+         else       { def letztring=EXTHNEring(EXTHNEnumber); }
+         if (minpoly==0) { 
+           def EXTHNEring(EXTHNEnumber)=SaveRing;
+           setring EXTHNEring(EXTHNEnumber);
+           if (not(defined(f))) {poly f; f=hole(f); export f;}
+           if ((size(HNEs)==1) and (typeof(HNEs[1])=="ideal")) {HNEs=list();}
+           list dummyL=imap(letztring,HNEs);
+           HNEs[size(HNEs)+1..size(HNEs)+size(dummyL)]=dummyL[1..size(dummyL)];
+           kill dummyL,letztring,SaveRing;
+         }
+         else { // muessen Daten nach SaveRing uebertragen;
+           setring HNE_noparam;
+           if (not(defined(HNEs))) { list HNEs; } 
+           HNEs=imap(letztring,HNEs);
+           def EXTHNEring(EXTHNEnumber)=SaveRing;
+           setring EXTHNEring(EXTHNEnumber);
+           if (not(defined(hole))) { map hole; }
+           hole=HNE_noparam,transfproc,x,y;
+           list dummyL=hole(HNEs);
+           if (not(defined(HNEs))) { def HNEs=list(); }
+           if ((size(HNEs)==1) and (typeof(HNEs[1])=="ideal")) {HNEs=list();}
+           HNEs[size(HNEs)+1..size(HNEs)+size(dummyL)]=dummyL[1..size(dummyL)];
+           kill dummyL, letztring,SaveRing;
+         }
+       }
+     }
+   }
+   // -----------------end of new part (loop for essential=1) ---------------- 
+  } // end (Loop uber Kanten)
+  if (defined(SaveRing)) { kill SaveRing; }
  }
  else {
-  HNEs[1]=list(hqs)+azeilen+list(f); // f ist das transform. Poly oder Null
-  export HNEs;
-  keepring basering;
-  return(list(HNEs,poly(-1)));
- //-- in dieser proc trat keine Verzweigung auf, also auch kein Ringwechsel ---
- }
-}
+  HNEs[1]=list(hqs)+azeilen+list(fneu); // fneu ist transform. Poly oder Null
+  conj1[1]=conj_factor;
+ } 
+
+ if (Aufruf_Ebene == 1)
+ {
+   if ((number_of_letztring!=EXTHNEnumber) and (not(defined(hne))))
+   { 
+     //----- falls Zweige in transz. Erw. berechnet werden konnten ---------
+     if (defined(transfproc)) 
+     { // --- Ringwechsel hat stattgefunden ---
+       if (defined(HNDebugOn)) {" ring change in HN(",1,") detected";}
+       if (not(defined(hole))) { map hole; }
+       hole=HNE_noparam,transfproc,x,y;
+       setring HNE_noparam;
+       f=imap(HNEring,f);
+       if (number_of_letztring==0) { def letztring=HNEring; }
+       else                        { def letztring=EXTHNEring(EXTHNEnumber); }
+       if (not(defined(hne))) { list hne; }
+       hne=imap(letztring,hne);
+       setring EXTHNEring(EXTHNEnumber);
+       if (not(defined(f))) { poly f=hole(f); export f; }
+       list hne=hole(hne);
+       export hne;
+     }
+   }
+   if (size(HNEs)>0) {
+     if ((size(HNEs)>1) or (typeof(HNEs[1])!="ideal") or (size(HNEs[1])>0)) {
+       if ((typeof(hne[1])=="ideal")) { hne=list(); }
+       hne=hne+extractHNEs(HNEs,getauscht);
+       if (hne_conj==0) { hne_conj=conj1; }
+       else { hne_conj = hne_conj, conj1; }
+     }
+   }
+ }
+ else
+ { // HN wurde rekursiv aufgerufen 
+   if (number_of_letztring!=EXTHNEnumber)
+   { // Ringwechsel hatte stattgefunden
+     string mipl_alt = string(minpoly);
+     execute("ring tempRing = ("+charstr(basering)+"),("+varstr(basering)+
+                              "),("+ordstr(basering)+");"); 
+     execute("minpoly="+ mipl_alt +";");
+     list HNEs=imap(EXTHNEring(EXTHNEnumber),HNEs);
+     export HNEs;
+     if (defined(HNDebugOn)) {" ! tempRing defined ! ";} 
+   } 
+   if (conj1!=0) { hne_conj=conj1; }
+   else          { hne_conj=conj_factor; }
+ }
+ if (EXTHNEnumber>0){ EXTHNEring = EXTHNEring(1..EXTHNEnumber); }
+ HNE_RingDATA = list(HNEring, HNE_noparam, EXTHNEnumber, EXTHNEring);
+ if (number_of_letztring==EXTHNEnumber) {
+   return(list(HNE_RingDATA,EXTHNEnumber,field_ext,HNEs,hne_conj));
+ }
+ else {
+   if (defined(tempRing)) {
+     return(list(HNE_RingDATA,EXTHNEnumber,field_ext,tempRing,hne_conj));
+   }
+   return(list(HNE_RingDATA,EXTHNEnumber,field_ext,0,hne_conj));
+ }
+}
+
 ///////////////////////////////////////////////////////////////////////////////
 
@@ -4015,5 +4074,5 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-proc factorlist (list L)
+proc factorlist (list L, list #)
 "USAGE:   factorlist(L);   L a list in the format of `factorize'
 RETURN:  the nonconstant irreducible factors of
@@ -4024,10 +4083,18 @@
 "
 {
+ int k;
+ if ((size(#)>=1) and ((typeof(#[1])=="intvec") or (typeof(#[1])=="int"))) { 
+   int with_conj = 1; intvec C = #[1]; 
+ } 
+ else { 
+   int with_conj = 0; intvec C = L[2]; 
+ }
  // eine Sortierung der Faktoren eruebrigt sich, weil keine zwei versch.
  // red.Fakt. einen gleichen irred. Fakt. haben koennen (I.3.27 Diplarb.)
  int i,gross;
  list faktoren,hilf;
+ intvec conjugates;
  ideal hil1,hil2;
- intvec v,w;
+ intvec v,w,hilf_conj;
  for (i=1; (L[1][i] == jet(L[1][i],0)) && (i<size(L[1])); i++) {;}
  if (L[1][i] != jet(L[1][i],0)) {
@@ -4037,17 +4104,19 @@
  // der Monomordnung!!! Im Beispiel unten verschwindet der Faktor x+y+1, wenn
  // man ds statt dp als Ordnung nimmt!
+   hilf_conj=C[i];
+   for (k=2;k<=size(hilf[2]);k++){ hilf_conj=hilf_conj,C[i]; }
    hilf[2]=hilf[2]*L[2][i];
    hil1=hilf[1];
    gross=size(hil1);
    if (gross>1) {
-       // faktoren=list(hilf[1][2..gross],hilf[2][2..gross]);
-       // -->  `? indexed object must have a name'
      v=hilf[2];
      faktoren=list(ideal(hil1[2..gross]),intvec(v[2..gross]));
-   }
-   else         { faktoren=hilf; }
+     conjugates=intvec(hilf_conj[2..gross]);
+   }
+   else         { faktoren=hilf; conjugates=hilf_conj; }
  }
  else {
    faktoren=L;
+   conjugates=C;
  }
 
@@ -4060,4 +4129,5 @@
        faktoren[1]=hil1;
        v=faktoren[2],L[2][i];
+       conjugates=conjugates,C[i];
        faktoren[2]=v;
      }
@@ -4066,4 +4136,6 @@
    else {
      hilf=factorize(L[1][i]);
+     hilf_conj=C[i];
+     for (k=2;k<=size(hilf[2]);k++){ hilf_conj=hilf_conj,C[i]; }
      hilf[2]=hilf[2]*L[2][i];
      hil1=faktoren[1];
@@ -4077,13 +4149,15 @@
      w=hilf[2];
      v=faktoren[2],w[2..gross];
+     conjugates=conjugates,hilf_conj[2..gross];
      faktoren[2]=v;
    }
  }
- return(faktoren);
+ if (with_conj==0) { return(faktoren); }
+ else { return(list(faktoren,conjugates)); }  // for essential development
 }
 example
 { "EXAMPLE:"; echo = 2;
  ring exring=0,(x,y),ds;
- list L=ideal(x,(x-y)^2*(x+y+1),x+y),intvec(2,2,1);
+ list L=list(ideal(x,(x-y)^2*(x+y+1),x+y),intvec(2,2,1));
  L;
  factorlist(L);
@@ -4172,221 +4246,2 @@
 
 ///////////////////////////////////////////////////////////////////////////////
-
-
-proc hnexpansion(poly f,list #)
-"USAGE:   hnexpansion(f); or hnexpansion(f,\"ess\");  f poly
-
-USAGE:   hnexpansion(f); f poly
-ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
-CREATE:  ring with variables @code{x,y} and ordering @code{ls} over a 
-         field extension of the current basering's ground field,         
-         since the Hamburger-Noether development usually does not exist
-         in the originally given basering. The field extension is chosen
-         minimally.@*
-         Moreover, in the ring a list @code{hne} of lists @code{hne[i]} is 
-         created (corresponding to the output of @code{develop(f[i])}, 
-         f[i] a branch of f, but the last entry being omitted).
-@texinfo
-@table @asis
-@item @code{hne[i][1]}; matrix:
-         Each row contains the coefficients of the corresponding line of the
-         Hamburger-Noether expansion (HNE) for f[i]. The end of the line is
-         marked in the matrix by the first ring variable (usually x).
-@item @code{hne[i][2]}; intvec:
-         indicating the length of lines of the HNE
-@item @code{hne[i][3]}; int:
-         0  if the 1st ring variable was transversal (with respect to f[i]), @*
-         1  if the variables were changed at the beginning of the
-            computation, @*
-        -1  if an error has occurred.
-@item @code{hne[i][4]}; poly:
-         the transformed polynomial of f[i] to make it possible to extend the
-         Hamburger-Noether development a posteriori without having to do
-         all the previous calculation once again (0 if not needed)
-@end table
-@end texinfo
-RETURN:  a list, say @code{hn}, containing the created ring 
-NOTE:    to use the ring type: @code{def HNEring=hn[i]; setring HNEring;}.
-         @*
-         If f is known to be irreducible as a power series, @code{develop(f)}
-         could be chosen instead to avoid the change of basering. @*
-         Increasing  @code{printlevel} leads to more and more comments.
-
-USAGE:   hnexpansion(f,\"ess\"); f poly
-ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
-CREATE:  ring with variables @code{x,y} and ordering @code{ls} over a 
-         field extension of the current basering's ground field,         
-         since the Hamburger-Noether development usually does not exist
-         in the originally given basering. The field extension is chosen
-         minimally.
-         @*
-         Moreover, in the ring a list @code{hne} of lists @code{hne[i]} is 
-         created (corresponding to the output of @code{develop(f[i])}, f[i] an
-         \"essential\" branch of f, but the last entry being omitted). See 
-         @code{hnexpansion} above for more details.
-RETURN:  a list, say @code{hn}, containing the created ring 
-NOTE:    to use the ring type: @code{def hnering=hn[i]; setring hnering;}.
-         @*
-         Alternatively you may use the procedure sethnering and type: 
-         @code{sethnering(hn);}
-         @*
-         If the HNE needs a field extension, some of the branches will be
-         conjugate. In this case @code{hnexpansion(f,\"ess\")} reduces the 
-         computation to one representative for each group of conjugate 
-         branches.@*
-         Note that the degree of each branch is in general less than the degree
-         of the field extension in which all HNEs can be put.@*
-         Use @code{hnexpansion(f)} to compute a complete HNE, i.e., a HNE for 
-         all branches.@*
-         Increasing  @code{printlevel} leads to more and more comments.        
-SEE ALSO: develop, extdevelop, parametrisation, displayHNE
-EXAMPLE: example hnexpansion;  shows an example
-"
-{
-  def rettering=basering;
-  if (defined(HNEring))
-  {
-    def @HNEring = HNEring;  
-    kill HNEring;
-  }
-  if (size(#)==1)
-  {
-    list hne=essdevelop(f);
-  }
-  else
-  {
-    list hne=HNdevelop(f);
-  }
-  export hne;
-  list hnereturn=HNEring;
-  setring rettering;
-  kill HNEring;
-  if (defined(@HNEring))
-  {
-    def HNEring=@HNEring;  
-    export(HNEring);
-  }
-  dbprint(printlevel-voice+2,"
-// 'hnexpansion' created a list containing a ring, which
-// contains the Hamburger-Noether expansion as a list hne.
-// To see the ring, type (if the name of your list is hn):
-     show(hn);
-// To access the ring and list, type:
-     def hnering = hn[1]; 
-     setring hnering;
-     hne;
-////////////////////////////////////////////////");
-
-  return(hnereturn);
-}
-example
-{
-  "EXAMPLE:"; echo = 2;
-  ring r=0,(x,y),ls;
-  list hn=hnexpansion(x4-y6);
-  show(hn);
-  
-  def hnering=hn[1];
-  setring hnering;
-  size(hne);           // number of branches
-  print(hne[1][1]);    // HN-matrix of 1st branch
-  parametrisation(hne);    // parametrization of the two branches
-  /////////////////////////////////////////////////////////
-  ring s=2,(x,y),ls;
-  poly f=(x4+x2y+y2)*(x3+xy2+y3);
-  // --------- compute all branches: ---------
-  hn=hnexpansion(f);
-  hnering=hn[1];
-  setring hnering;
-  displayHNE(hne[1]);   // HN-matrix of 1st branch
-  displayHNE(hne[4]);   // HN-matrix of 4th branch
-  setring s;
-  // --- compute only one of conjugate branches: ---
-  hn=hnexpansion(f,"ess");
-  hnering=hn[1];
-  setring hnering;
-  displayHNE(hne);
-  // no. 1 of hnexpansion(f,"ess") represents no. 1 - 3 of hnexpansion(f) and
-  // no. 2 of hnexpansion(f,"ess") represents no. 4 + 5 of hnexpansion(f)
-}
-///////////////////////////////////////////////////////////////////////////////
-
-proc sethnering (list L,list #)
-"USAGE:  sethnering(L[,s]); L list, s string (optional)
-ASSUME:  L is a list containing a ring (e.g. the output of @code{hnexpansion}).
-CREATE:  The procedure creates a ring with name given by the optional parameter
-         s resp. with name hnering, if no optional parameter is given, and
-         changes your ring to this ring. The new ring will be the ring given 
-         as the first entry in the list L.          
-RETURN:  nothing. 
-SEE ALSO: hnexpansion
-EXAMPLE: example sethnering; shows some examples.
-"
- 
-{
-  if (typeof(L[1])=="ring")
-  {
-    if (size(#)>0)
-    {
-      if (typeof(#[1])=="string")
-      {        
-        execute("def "+#[1]+"=L[1];");
-        execute("export "+#[1]+";");
-        execute("setring "+#[1]+";");
-        execute("keepring "+#[1]+";");
-      }
-      else
-      {
-        ERROR("Optional Input was no string.");
-        return();
-      }
-    }
-    else
-    {
-      def hnering=L[1];
-      export hnering;
-      setring hnering;
-      keepring hnering;
-    }
-    return();
-  }
-  else
-  {
-    ERROR("Input was no hnering.");
-    return();
-  }
-}
-example
-{
-  // -------- prepare for example ---------
-  if (defined(hnering))
-  {
-   def rette@ring=hnering;
-   if (nameof(basering)=="hnering")
-   {
-     int wechsel=1;
-   }
-   else
-   {
-     int wechsel;
-   }
-   kill hnering;
-  }
-  // ------ the example starts here -------
-  "EXAMPLE:"; echo = 2;
-  ring r=0,(x,y),ls;
-  nameof(basering);
-  sethnering(hnexpansion(x4-y6)); // Creates hnering and changes to it!
-  nameof(basering);
-  echo = 0;
-  // --- restore HNEring if previously defined ---
-  kill hnering;
-  if (defined(rette@ring)) {
-   def hnering=rette@ring;
-   export hnering;
-   if (wechsel==1)
-   {
-     setring hnering;
-   }
-  }
-}
